(*
	=====================================================================
    @\gŃtH[
	---------------------------------------------------------------------
		1.GNXv[̃hbOAhhbvΉ
        	1.St@CStringListɏ㏑ۑ
         	2.StH_StringListɏ㏑ۑ
            3.ʒu擾
            4.̈ʒuɂRg[ւ̎QƂ擾
            5.hbOAhhbvNΉ
	---------------------------------------------------------------------
		2.ʒu̍Č
        	1.NINIt@Cǂݍ
            2.IINIt@Cɏ
	---------------------------------------------------------------------
		3.Init@C
            1.string̏/ǂݍ
            2.Bool^̏/ǂݍ
	---------------------------------------------------------------------
		4.AvP[V
        	1.[Esc]ɂI
			2.VXej[Ƀo[W1
			@VXej[Ƀo[W2
            @VXej[ɃCXg[tH_I[v
	=====================================================================

*)
unit Base;

interface

uses
    Windows, Messages, SysUtils, Classes, Controls, Forms,
    Dialogs, ShellApi, IniFiles;

type
    TBaseForm = class(TForm)
        procedure FormCreate(Sender: TObject);
        procedure FormDestroy(Sender: TObject);
        procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
	    procedure FormShow(Sender: TObject);
    private
        { Private 錾 }
        procedure	LoadPosition();
        procedure	SavePosition();
		procedure	ParamDrops();
	    procedure	WMDropFiles(var Msg: TWMDROPFILES); message WM_DROPFILES;
        procedure	AppMessage(var Msg: TMsg; var Handled: Boolean);
    public
        { Public 錾 }
    protected
    	EscapeClose: Boolean;
    	DropFileList: TStringList;
    	DropFoldList: TStringList;
        DropPos: TPoint;
        DropControl: TControl;
        AppIni: TIniFile;
        procedure	DroppedAction(); virtual; abstract;
		procedure	UpdateDropList(AFileName: string);
		procedure	SaveIniString(AName, AValue: string);
		function	LoadIniString(AName: string; ADefault: string = 'Name'): string;
		procedure	SaveIniBoolean(AName: string; AValue: Boolean);
		function	LoadIniBoolean(AName: string; ADefault: Boolean = false): Boolean;
		procedure	SaveIniInteger(AName: string; AValue: integer);
		function	LoadIniInteger(AName: string; ADefault: integer = 0): integer;
        procedure	ModifySysMenu();
        procedure	WMSysCommand(var Msg: TWMSysCommand); message WM_SYSCOMMAND;
    end;

var
    BaseForm: TBaseForm;

implementation

uses
	iUtils, About;

{$R *.dfm}

(*
	=====================================================================
    RXgN^/fXgN^
	=====================================================================
*)

(* RXgN^ *)
procedure	TBaseForm.FormCreate(Sender: TObject);
begin
    //D&D֘A
    DragAcceptFiles(Handle, true);
	DropFileList	:= TStringList.Create;
	DropFoldList	:= TStringList.Create;
    DropPos			:= Point(-1, -1);
    DropControl		:= nil;
    //EscI
    EscapeClose := True;
    //INIIuWFNg쐬
	AppIni := TIniFile.Create(ChangeFileExt(Application.ExeName, '.ini'));
    //ʒu
    LoadPosition();
    //̑
    Self.Caption := Application.Title;
	//j[
    ModifySysMenu();
    //AvP[VbZ[Wnhݒ
    Application.OnMessage := AppMessage;
end;

(* fXgN^ *)
procedure	TBaseForm.FormDestroy(Sender: TObject);
begin
	//ʒuۑ
	SavePosition();
	//INIt@Cpj
	AppIni.Free;
	//pXۑpXgj
    DropFileList.Free;
    DropFoldList.Free;
	//t@Chbv
    DragAcceptFiles(Handle, False);
    //AvP[VbZ[Wnhݒ
    Application.OnMessage := nil;
end;

(*
	=====================================================================
    hbOAhhbvΉR[h
	=====================================================================
*)

(* hbvt@CXgXV *)
procedure	TBaseForm.UpdateDropList(AFileName: string);
begin
    try
        if IsFolderPath(AFileName) then
        begin
            DropFoldList.Add(AFileName);
        end
        else
        begin
            DropFileList.Add(AFileName);
        end;
    except
        ;	//
    end;
end;

(* t@ChbvɂN *)
procedure	TBaseForm.ParamDrops();
var
    i: integer;
begin
    DropFileList.Clear;
    DropFoldList.Clear;
	for i := 1 to ParamCount do
    begin
		UpdateDropList(ParamStr(i));
    end;
	DroppedAction();
end;

(* VF̃hbv *)
procedure	TBaseForm.WMDropFiles(var Msg: TWMDropFiles);
var
    i         : integer;
    FileName  : array [0..255]  of  char;
    FileCount : integer;
begin
    //hbvʒu
    DragQueryPoint(Msg.Drop, DropPos);
	//hbvʒũRg[
    DropControl := FindDragTarget(ClientToScreen(DropPos), False);
	//hbvt@C
    FileCount := DragQueryFile(Msg.Drop, $FFFFFFFF, FileName, SizeOf(FileName));
    //Xg쐬
    DropFileList.Clear;
    DropFoldList.Clear;
    for i := 0 to FileCount - 1 do begin
        DragQueryFile(Msg.Drop, i, FileName, SizeOf(FileName));
		UpdateDropList(FileName);
    end;
    DragFinish(Msg.Drop);
	DroppedAction();
end;

procedure TBaseForm.FormShow(Sender: TObject);
begin
	//hbvN̏
    ParamDrops();
end;

(*
	=====================================================================
    ʒuČ
	=====================================================================
*)

(* ʒuǍ *)
procedure	TBaseForm.LoadPosition();
begin
	Self.Top	:= LoadIniInteger('Top'			, Self.Top);
	Self.Left	:= LoadIniInteger('Left'		, Self.Left);
	Self.Width	:= LoadIniInteger('Width'		, Self.Width);
	Self.Height	:= LoadIniInteger('Height'		, Self.Height);
end;

(* ʒuۑ *)
procedure	TBaseForm.SavePosition();
begin
	SaveIniInteger('Top'		, Self.Top);
	SaveIniInteger('Left'		, Self.Left);
	SaveIniInteger('Width'		, Self.Width);
	SaveIniInteger('Height'		, Self.Height);
end;

(*
	=====================================================================
    AvP[V֌W
	=====================================================================
*)

(* [Esc]I *)
procedure	TBaseForm.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
	if EscapeClose and (Key = VK_ESCAPE) then
    begin
    	Self.Close;
    end;
end;

(*
	=====================================================================
    INIt@C
	=====================================================================
*)

(* ۑ *)
procedure	TBaseForm.SaveIniString(AName, AValue: string);
begin
	try
		AppIni.WriteString(Self.ClassName, AName, AValue);
    except
    	;
	end;
end;

(* ǂݍ *)
function	TBaseForm.LoadIniString(AName: string; ADefault: string = 'Name'): string;
begin
	try
		Result := AppIni.ReadString(Self.ClassName, AName, ADefault);
    except
    	Result := ADefault;
	end;
end;

(* _^ۑ *)
procedure	TBaseForm.SaveIniBoolean(AName: string; AValue: Boolean);
begin
	try
		AppIni.WriteBool(Self.ClassName, AName, AValue);
    except
    	;
	end;
end;

(* _^ǂݍ *)
function	TBaseForm.LoadIniBoolean(AName: string; ADefault: Boolean = false): Boolean;
begin
	try
		Result := AppIni.ReadBool(Self.ClassName, AName, ADefault);
    except
    	Result := ADefault;
	end;
end;

(* l^ۑ *)
procedure	TBaseForm.SaveIniInteger(AName: string; AValue: integer);
begin
	try
		AppIni.WriteInteger(Self.ClassName, AName, AValue);
    except
    	;
	end;
end;

(* l^ǂݍ *)
function	TBaseForm.LoadIniInteger(AName: string; ADefault: integer = 0): integer;
begin
	try
		Result := AppIni.ReadInteger(Self.ClassName, AName, ADefault);
    except
    	Result := ADefault;
	end;
end;

const
	idMenuBase = 100;
	idSysAbout = idMenuBase + 1;
    idExeDirct = idMenuBase + 3;

(* VXej[ύX *)
procedure	TBaseForm.ModifySysMenu();
var
	Menu: HMENU;
begin
    Menu := GetSystemMenu(Handle, False);
	//j[ǉ
    AppendMenu(Menu, MF_SEPARATOR, 0, '');
    AppendMenu(Menu, MF_STRING, idSysAbout, 'o[W');
    AppendMenu(Menu, MF_STRING, idExeDirct, 'CXg[tH_');
    //AvP[ṼVXej[ɂ
    Menu := GetSystemMenu(Application.Handle, False);
    AppendMenu(Menu, MF_SEPARATOR, 0, '');
    AppendMenu(Menu, MF_STRING, idSysAbout, 'o[W');
    AppendMenu(Menu, MF_STRING, idExeDirct, 'CXg[tH_');
end;

(* ǉj[ *)
procedure	TBaseForm.WMSysCommand(var Msg: TWMSysCommand);
begin
	case Msg.CmdType of
        idSysAbout  : AboutBox.ShowModal();
        idExeDirct  : ExecuteFile(ExtractFilePath(Application.ExeName));
    end;
    inherited;
end;

(* ǉj[2 *)
procedure	TBaseForm.AppMessage(var Msg: TMsg; var Handled: Boolean);
begin
    if (Msg.message = WM_SYSCOMMAND) then
    begin
		if (Msg.wParam = idSysAbout) then
        begin
            AboutBox.ShowModal();
            Handled := True;
        end
        else
		if (Msg.wParam = idExeDirct) then
        begin
            ExecuteFile(ExtractFilePath(Application.ExeName));
            Handled := True;
        end;
    end;
end;

end.
